#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll INF=numeric_limits<ll>::max();


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n,m;
    cin>>n>>m;
    vector<vector<ll> > v(n);

    for(ll i=0;i<n;i++){
        v[i].resize(m+2);
        for(ll j=1;j<=m;j++){
            cin>>v[i][j];

        }
    }
    for(ll i=1;i<=m;i++){
        v[1][i]+=v[1][i-1];
    }
    for(ll i=m;i>0;i--){
        v[0][i]+=v[0][i+1];
    }

    ll ans=INF;
    for(ll i=1;i<m;i++){
        ans=min(ans,v[1][i]+v[0][i+2]);
    }
    
    
    cout<<ans<<endl;

    return 0;
}